const dir = './.fk2';
const os = require('os');
const path = require('path');
module.exports = {
    work: paths(dir),
    run:paths(dir+'/run.json'),
    start:paths(dir+'/start.json'),
    server: paths(dir+'/server.json'),
    funct: paths(dir+'/fun'),
    host: paths(dir+'/host.json'),
    pid: paths(dir+'/pids'),
    pkg: paths(dir+'/pkg'),
    log: paths(dir+'/logs'),
    conf: paths(dir+'/conf.json'),
    path(url){
        if(!url) return paths(dir);
        return paths(dir+url)
    },
    ppath(url){
        return paths(dir+'/pids/'+url)
    }
}
function paths(urls) {
    if(urls){
        return path.join(os.homedir(),'./'+urls)
    }
    return os.homedir()
}