// 监听目录变化
const fs = require('fs');
const path = require('path');
module.exports = (url, funct) => {
    // 监听目录变化
    watch(url, funct);
}
function watch(url, funct) {
    // 进入文件夹
    var ls = fs.readdirSync(url);
    const fswatch = fs.watch(url, (e, f) => {
        // 在次进入
        var lss = [];
        try {
            lss = fs.readdirSync(url);
        } catch (error) {
            fswatch.close();
            return
        }
        const fpath = path.join(url, f);
        var res = {
            type: 'add',
            file: isFile(fpath),
            url: fpath
        }
        if(ls.includes(f)){
            // 之前存在 可能是修改
            if(isFile(fpath)==null){
                res.type = 'del'
            }else{
                res.type = 'upd'
            }
        }
        ls = lss;
        return funct(res);
    })
    fswatch.on('error',(err)=>{
        fswatch.close();
    })
}
function isFile(url) {
    try {
        return fs.statSync(url).isFile();
    } catch (error) {
        return null
    }
}

