const arg = process.argv;
const reg = require('../plug-in/setReg');
const save = require('../plug-in/confSave')
const logs = require('../plug-in/colorLog');
const readline = require('readline').createInterface({
    input: process.stdin,
    output: process.stdout
})
const obj = {
    workOpen:{
        type:'binary',
        regs:'0 or 1',
        info:'1 is Open work site!'
    },
    workHost:{
        type:'host',
        regs:'ip or domain',
        info:'IP Web or domain name!'
    },
    workPort:{
        type:'port',
        regs:'A Number ',
        info:'The Free Port(fk2 work)!'
    },
    runHttp:{
        type:'port',
        regs:'A Number ',
        info:'The Free Port(fk2 run)!'
    },
    runHttps:{
        type:'port',
        regs:'A Number ',
        info:'The Free Port(fk2 run)!'
    }
}

setting()

async function setting() {
    if(!arg[3]){
        //所有设置参数
        aLog();
    }else{
        const args = arg[3].split('=')
        if(!obj[args[0]]) {
            logs.r(`This obj '${args[0]}' does not exist!`)
            return
        }else if(args.length==1){
            quest(args[0])
        }else{
            if(!reg[obj[args[0]]['type']](args[1])){
                // 验证输入参数
                logs.r(`This obj arg is error!`)
                quest(args[0],args[1]);
                return
            }else{
                // 通过验证保存
                await save(args[0],args[1]);
                aLog();
            }
        }
    }
}

function quest(a) {
    logs.close();
    const ta = '\033[35m '+a+': '
    readline.question(ta,async (data) => {
        if(!reg[obj[a]['type']](data)){
            logs.close();
            logs.r(` The '${a}' can't be '${data}'`)
            quest(a);
        }else{
            // 通过验证保存
            await save(a,data);
            aLog();
        }
    })
}
function aLog() {
    logs.close();
    logs.y(' Please select the arg Index!\033[0m')
    logs.close();
    const len = Object.keys(obj).length-1;
    const text = '\033[35m Select index [0-'+len+']: '
    var arr = []
    for (const key in obj) {
        arr.push({
            'arg':key,
            'type':obj[key].regs,
            'info':obj[key].info
        })
    }
    console.table(arr)
    relog();
    function relog() {
        logs.close();
        readline.question(text, (data)=>{
            if(data&&data>-1&&data<len+1&&data%1 === 0){
                quest(Object.keys(obj)[data])
            }else{
                logs.close();
                logs.r(' Input error !');
                aLog();
            }
        })
    }

}




